/*
    SelectFilesCmd.h - return selected source and destination filenames

    Will 18, 2001: will@opaline.demon.co.uk
*/

#ifndef SELECTFILESCMD_H
#define SELECTFILESCMD_H


#include <NoUndoCmd.h>

#define BUFSIZE 1024

class FileSelect;


typedef void ( *SelectFilesCallback ) ( void *, char *, char * );

class FileSelect;

class SelectFilesCmd : public NoUndoCmd
{
	protected:
		virtual void doCommand();	// SelectFiles
		SelectFilesCallback _callback;
		void *_clientData;
		char *_name;
		
	public:
		SelectFilesCmd ( char *, int, SelectFilesCallback, char *, char *, Boolean, void * );

	private:
		static void sourceSelectedCallback ( void *, char * );
		static void targetSelectedCallback ( void *, char * );
		static void fileSelectCancelledCallback ( void * );
		static void sourceCancelledCallback ( void * );
		static void targetCancelledCallback ( void * );

		// overwrite dialog callbacks
		static void overwriteOkCallback ( void * );
		static void overwriteCancelCallback ( void * );

		void SelectFiles ( int );
		void sourceSelected ( char * );
		void targetSelected();

		void isDstFile ( char * );
		char _srcFileName[BUFSIZE];
		char _dstFileName[BUFSIZE];
		FileSelect *_src, *_dst;
		char *_title1;
		char *_title2;
		Boolean _selectFiles;
		Boolean _overwrite;
};


#endif

/*
   Notes:
  
   help callback not implemented.
   
   The use of this class is dual. If the Boolean variable oversrite is true,
   then a check is made for an existing target file and prompt issued. If the
   Boolean variable is false, then no check is made for a target file, and a
   null name value may be returned. This allows for use as 'source/target'
   mode selection in the first case and 'dual file' select in the second, where
   it is intended that both files selected are for read; in the former case,
   the target file is assumed writeable.
*/
  
