/*
    TemplateSizeCmd.cc
 
    Will Eighteen, 2006: will@opaline.demon.co.uk             
*/

#include "TemplateSizeCmd.h"
#include "Application.h"
#include <LineEdit.h>
#include "OpResources.h"	// this is the only resources file with global resources


TemplateSizeCmd::TemplateSizeCmd ( const char *name, int active ) :  Cmd ( name, active )
{
	_popupRealised = False;
}


void TemplateSizeCmd::doCommand()
{
	if ( _popupRealised == True )
		return;

	char buf[30];
	
	_edit = new LineEdit ( ( char * ) name(), TRUE,
									&TemplateSizeCmd::enterCallback,
									&TemplateSizeCmd::cancelCallback, ( void * ) this );	
	
	/* retrieve resource to be displayed */
 	snprintf ( buf, sizeof ( buf ), "%d", mixwaveResources->defaultTemplateSize() );
	buf [ sizeof ( buf ) - 1 ] = 0;
	_edit->setColumns ( strlen ( buf ) );	// set width before instantiation
	_edit->setHelp ( "Number of control points in template file (applied over \
duration of wave)." );
	_edit->execute();
	_edit->setText ( buf );	// can't set text before instantiation...
	_popupRealised = True;
}


void TemplateSizeCmd::undoCommand()
{
	// not implemented
}


void TemplateSizeCmd::enterCallback ( void *clientData, char *text )
{
	int num;

	TemplateSizeCmd *obj = ( TemplateSizeCmd * ) clientData;
	sscanf ( text, "%d", &num );	

	if ( num >= 0 )
		obj->enter ( num );

	obj->_popupRealised = False;
	delete obj->_edit;
}

/* specify resource to be set on 'enter' or 'ok' */
void TemplateSizeCmd::enter ( int num )
{
	mixwaveResources->defaultTemplateSize ( num );
}


void TemplateSizeCmd::cancelCallback ( void *clientData )
{
	TemplateSizeCmd *obj = ( TemplateSizeCmd * ) clientData;
	
	obj->_popupRealised = False;
	delete obj->_edit;
}
